Page MenuHomeFreeBSD

boot2 will deadlock if extended keys are used on text input
ClosedPublic

Authored by tsoome on Nov 21 2016, 9:04 PM.
Tags
None
Referenced Files
Unknown Object (File)
Sun, Feb 18, 12:22 AM
Unknown Object (File)
Thu, Feb 8, 10:09 PM
Unknown Object (File)
Jan 15 2024, 2:30 PM
Unknown Object (File)
Dec 22 2023, 4:50 PM
Unknown Object (File)
Dec 20 2023, 1:16 AM
Unknown Object (File)
Dec 16 2023, 2:38 PM
Unknown Object (File)
Dec 16 2023, 2:38 PM
Unknown Object (File)
Dec 2 2023, 12:57 PM
Subscribers

Details

Summary

The boot2 family of bootblocks (zfsboot/gptzfsboot) are using separate
implementation if keyboard reading code, which has deadlock case when
extended key (arrows etc) are pressed.

The problem is about avoiding the noise from some systems, generating
false key events with scan code 1 and ascii code 00, so the code
does attempt to filter such cases out. Unfortunately the extended keys
also set ascii 0, and therefore the pressed key event is ignored and
the keypress is never read, resulting in infinite loop.

This update is moving the check to keyhit() function and is allowing
the rest of the code to process the extended keys.

Test Plan

boot2 prompt is not getting locked up.

Diff Detail

Repository
rS FreeBSD src repository - subversion
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

tsoome retitled this revision from to boot2 will deadlock if extended keys are used on text input.
tsoome updated this object.
tsoome edited the test plan for this revision. (Show Details)
tsoome added reviewers: allanjude, imp.
bapt edited edge metadata.
This revision is now accepted and ready to land.Dec 18 2016, 10:55 PM
allanjude edited edge metadata.

Approved for commit

This revision was automatically updated to reflect the committed changes.